/************************************************************************************
**	ȨУCopyright (c) 2005 - 2010 ICRoute INC.
** Ӳ˵STM32f103vet6  8MHZ  ڲʱΪ72MHZ 
** 					 LD3320 Դ 12MHZ  ͬľ޸LDChip.h еĶֵdefine CLK_IN  12
** ˵ждĴʽʽ޸Reg_RW.c ļɣ
** ޸:  http://shop64790118.taobao.com/
** ʱ䣺2011.10.15
** ˵޸ ICRoute˾ ׵Դ򣬰ȨС
************************************************************************************/

#ifndef LD_CHIP_H
#define LD_CHIP_H

#define uint8 unsigned char
#define uint16 unsigned int
#define uint32 unsigned long

//	״̬¼ASRʶMP3
#define LD_MODE_IDLE		0x00
#define LD_MODE_ASR_RUN		0x08
#define LD_MODE_MP3		 	0x40


//	״̬¼ASRʶеĸ״̬
#define LD_ASR_NONE				0x00	//	ʾûASRʶ
#define LD_ASR_RUNING			0x01	//	ʾLD3320ASRʶ
#define LD_ASR_FOUNDOK			0x10	//	ʾһʶ̽һʶ
#define LD_ASR_FOUNDZERO 		0x11	//	ʾһʶ̽ûʶ
#define LD_ASR_ERROR	 		0x31	//	ʾһʶLD3320оƬڲֲȷ״̬


#define CLK_IN   	22	/* user need modify this value according to clock in */
#define LD_PLL_11			(uint8)((CLK_IN/2)-1)
#define LD_PLL_MP3_19		0x0f
#define LD_PLL_MP3_1B		0x18
#define LD_PLL_MP3_1D   	(uint8)(((90*((LD_PLL_11)+1))/(CLK_IN))-1)

#define LD_PLL_ASR_19 		(uint8)(CLK_IN*32/(LD_PLL_11+1) - 0.51)
#define LD_PLL_ASR_1B 		0x48
#define LD_PLL_ASR_1D 		0x1f

// LD chip fixed values.
#define        RESUM_OF_MUSIC               0x01
#define        CAUSE_MP3_SONG_END           0x20

#define        MASK_INT_SYNC				0x10
#define        MASK_INT_FIFO				0x04
#define    	   MASK_AFIFO_INT				0x01
#define        MASK_FIFO_STATUS_AFULL		0x08



void LD_reset(void);

void LD_Init_Common(void);

void LD_Init_ASR(void);

void LD_ReloadMp3Data(void);
void LD_ReloadMp3Data_2(void);

uint8 LD_ProcessAsr(uint32 RecogAddr);
void LD_AsrStart(void);
uint8 LD_AsrRun(void);
uint8 LD_AsrAddFixed(void);
uint8 LD_GetResult(void);

void LD_ReadMemoryBlock(uint8 dev, uint8 * ptr, uint32 addr, uint8 count);
void LD_WriteMemoryBlock(uint8 dev, uint8 * ptr, uint32 addr, uint8 count);

extern uint8  nLD_Mode;


#define CODE_KAIDENGD	0
#define CODE_GUANDENG	1
#define CODE_FANGJIANA	3
#define CODE_TIANJIN	7
#define CODE_CHONGQING	8

void  LD3320_delay(unsigned long uldata);
void  LD3320_delay_2(unsigned long uldata);

#define MIC_VOL 0x43
#endif
